###############################################################################
##
## Copyright (c) 2007 Zope Foundation and Contributors.
## All Rights Reserved.
##
## This software is subject to the provisions of the Zope Public License,
## Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
## THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
## WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
## WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
## FOR A PARTICULAR PURPOSE.
##
###############################################################################
#"""Z3c development recipes
#
#$Id:$
#"""
#
#import os, sys
#import pkg_resources
#import zc.buildout.easy_install
#import zc.recipe.egg
#
#
#class DevSetup:
#
#    def __init__(self, buildout, name, options):
#        self.egg = None
#        self.buildout = buildout
#        self.name = name
#        self.options = options
#        options['script'] = os.path.join(buildout['buildout']['bin-directory'],
#                                         options.get('script', self.name),
#                                         )
#        if not options.get('working-directory', ''):
#            options['location'] = os.path.join(
#                buildout['buildout']['parts-directory'], name)
#
#        if options.get('eggs'):
#            self.egg = zc.recipe.egg.Egg(buildout, name, options)
#
#        # get the workspace dir
#        directory = buildout['buildout']['directory']
#        workspace = options['workspace']
#        self.workspace = os.path.join(directory, workspace)
#
#    def install(self):
#        options = self.options
#        dest = []
#
#        if self.egg:
#            extra_paths = self.egg.extra_paths
#            extra_paths = [self.workspace] + extra_paths
#            eggs, ws = self.egg.working_set()
#
#            test_paths = [ws.find(pkg_resources.Requirement.parse(spec)).location
#                          for spec in eggs]
#        else:
#            extra_paths = [self.workspace]
#            test_paths = [self.workspace]
#            ws = []
#
#        executable = self.buildout['buildout']['executable']
#
#        defaults = options.get('defaults', '').strip()
#        if defaults:
#            defaults = '(%s) + ' % defaults
#
#        wd = options.get('working-directory', options['location'])
#        if os.path.exists(wd):
#            assert os.path.isdir(wd)
#        else:
#            os.mkdir(wd)
#        dest.append(wd)
#        initialization = initialization_template % wd
#
#        env_section = options.get('environment', '').strip()
#        if env_section:
#            env = self.buildout[env_section]
#            for key, value in env.items():
#                initialization += env_template % (key, value)
#
#        dest.extend(zc.buildout.easy_install.scripts(
#            [(options['script'], 'zope.testing.testrunner', 'run')],
#            ws, executable, self.buildout['buildout']['bin-directory'],
#            extra_paths=extra_paths,
#            arguments = defaults + (arg_template % dict(
#                TESTPATH=repr(test_paths)[1:-1].replace(
#                               ', ', ",\n  '--test-path', "),
#                )),
#            initialization = initialization,
#            ))
#
#        return dest
#
#    update = install
#
#
#arg_template = """[
#  '--test-path', %(TESTPATH)s,
#  ]"""
#
#
#initialization_template = """import os
#sys.argv[0] = os.path.abspath(sys.argv[0])
#os.chdir(%r)
#"""
#
#env_template = """os.environ['%s'] = %r
#"""
